diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/upgrade.php ./wordpress-3.4/wp-admin/includes/upgrade.php
*** ./wordpress-3.3.2/wp-admin/includes/upgrade.php	2011-11-28 14:35:36.000000000 -0600
--- ./wordpress-3.4/wp-admin/includes/upgrade.php	2012-05-02 16:19:37.000000000 -0500
***************
*** 35,42 ****
   * @return array Array keys 'url', 'user_id', 'password', 'password_message'.
   */
  function wp_install( $blog_title, $user_name, $user_email, $public, $deprecated = '', $user_password = '' ) {
- 	global $wp_rewrite;
- 
  	if ( !empty( $deprecated ) )
  		_deprecated_argument( __FUNCTION__, '2.6' );
  
--- 35,40 ----
***************
*** 58,65 ****
  	if ( ! $public )
  		update_option('default_pingback_flag', 0);
  
! 	// Create default user.  If the user already exists, the user tables are
! 	// being shared among blogs.  Just set the role in that case.
  	$user_id = username_exists($user_name);
  	$user_password = trim($user_password);
  	$email_password = false;
--- 56,63 ----
  	if ( ! $public )
  		update_option('default_pingback_flag', 0);
  
! 	// Create default user. If the user already exists, the user tables are
! 	// being shared among blogs. Just set the role in that case.
  	$user_id = username_exists($user_name);
  	$user_password = trim($user_password);
  	$email_password = false;
***************
*** 74,80 ****
  		$message = '<em>'.__('Your chosen password.').'</em>';
  		$user_id = wp_create_user($user_name, $user_password, $user_email);
  	} else {
! 		$message =  __('User already exists. Password inherited.');
  	}
  
  	$user = new WP_User($user_id);
--- 72,78 ----
  		$message = '<em>'.__('Your chosen password.').'</em>';
  		$user_id = wp_create_user($user_name, $user_password, $user_email);
  	} else {
! 		$message = __('User already exists. Password inherited.');
  	}
  
  	$user = new WP_User($user_id);
***************
*** 82,88 ****
  
  	wp_install_defaults($user_id);
  
! 	$wp_rewrite->flush_rules();
  
  	wp_new_blog_notification($blog_title, $guessurl, $user_id, ($email_password ? $user_password : __('The password you chose during the install.') ) );
  
--- 80,86 ----
  
  	wp_install_defaults($user_id);
  
! 	flush_rewrite_rules();
  
  	wp_new_blog_notification($blog_title, $guessurl, $user_id, ($email_password ? $user_password : __('The password you chose during the install.') ) );
  
***************
*** 147,184 ****
  
  	// Now drop in some default links
  	$default_links = array();
! 	$default_links[] = array(	'link_url' => 'http://codex.wordpress.org/',
! 								'link_name' => 'Documentation',
  								'link_rss' => '',
  								'link_notes' => '');
  
! 	$default_links[] = array(	'link_url' => 'http://wordpress.org/news/',
! 								'link_name' => 'WordPress Blog',
! 								'link_rss' => 'http://wordpress.org/news/feed/',
  								'link_notes' => '');
  
! 	$default_links[] = array(	'link_url' => 'http://wordpress.org/extend/ideas/',
! 								'link_name' => 'Suggest Ideas',
  								'link_rss' => '',
  								'link_notes' =>'');
  
! 	$default_links[] = array(	'link_url' => 'http://wordpress.org/support/',
! 								'link_name' => 'Support Forum',
  								'link_rss' => '',
  								'link_notes' =>'');
  
! 	$default_links[] = array(	'link_url' => 'http://wordpress.org/extend/plugins/',
! 								'link_name' => 'Plugins',
  								'link_rss' => '',
  								'link_notes' =>'');
  
! 	$default_links[] = array(	'link_url' => 'http://wordpress.org/extend/themes/',
! 								'link_name' => 'Themes',
  								'link_rss' => '',
  								'link_notes' =>'');
  
! 	$default_links[] = array(	'link_url' => 'http://planet.wordpress.org/',
! 								'link_name' => 'WordPress Planet',
  								'link_rss' => '',
  								'link_notes' =>'');
  
--- 145,182 ----
  
  	// Now drop in some default links
  	$default_links = array();
! 	$default_links[] = array(	'link_url' => __( 'http://codex.wordpress.org/' ),
! 								'link_name' => __( 'Documentation' ),
  								'link_rss' => '',
  								'link_notes' => '');
  
! 	$default_links[] = array(	'link_url' => __( 'http://wordpress.org/news/' ),
! 								'link_name' => __( 'WordPress Blog' ),
! 								'link_rss' => __( 'http://wordpress.org/news/feed/' ),
  								'link_notes' => '');
  
! 	$default_links[] = array(	'link_url' => __( 'http://wordpress.org/support/' ),
! 								'link_name' => _x( 'Support Forums', 'default link' ),
  								'link_rss' => '',
  								'link_notes' =>'');
  
! 	$default_links[] = array(	'link_url' => 'http://wordpress.org/extend/plugins/',
! 								'link_name' => _x( 'Plugins', 'Default link to wordpress.org/extend/plugins/' ),
  								'link_rss' => '',
  								'link_notes' =>'');
  
! 	$default_links[] = array(	'link_url' => 'http://wordpress.org/extend/themes/',
! 								'link_name' => _x( 'Themes', 'Default link to wordpress.org/extend/themes/' ),
  								'link_rss' => '',
  								'link_notes' =>'');
  
! 	$default_links[] = array(	'link_url' => __( 'http://wordpress.org/support/forum/requests-and-feedback' ),
! 								'link_name' => __( 'Feedback' ),
  								'link_rss' => '',
  								'link_notes' =>'');
  
! 	$default_links[] = array(	'link_url' => __( 'http://planet.wordpress.org/' ),
! 								'link_name' => __( 'WordPress Planet' ),
  								'link_rss' => '',
  								'link_notes' =>'');
  
***************
*** 302,308 ****
  
  		// Delete any caps that snuck into the previously active blog. (Hardcoded to blog 1 for now.) TODO: Get previous_blog_id.
  		if ( !is_super_admin( $user_id ) && $user_id != 1 )
! 			$wpdb->query( $wpdb->prepare("DELETE FROM $wpdb->usermeta WHERE user_id = %d AND meta_key = %s", $user_id, $wpdb->base_prefix.'1_capabilities') );
  	}
  }
  endif;
--- 300,306 ----
  
  		// Delete any caps that snuck into the previously active blog. (Hardcoded to blog 1 for now.) TODO: Get previous_blog_id.
  		if ( !is_super_admin( $user_id ) && $user_id != 1 )
! 			$wpdb->delete( $wpdb->usermeta, array( 'user_id' => $user_id , 'meta_key' => $wpdb->base_prefix.'1_capabilities' ) );
  	}
  }
  endif;
***************
*** 358,364 ****
  
  	$wp_current_db_version = __get_option('db_version');
  
! 	// We are up-to-date.  Nothing to do.
  	if ( $wp_db_version == $wp_current_db_version )
  		return;
  
--- 356,362 ----
  
  	$wp_current_db_version = __get_option('db_version');
  
! 	// We are up-to-date. Nothing to do.
  	if ( $wp_db_version == $wp_current_db_version )
  		return;
  
***************
*** 391,400 ****
   * @since 1.0.1
   */
  function upgrade_all() {
! 	global $wp_current_db_version, $wp_db_version, $wp_rewrite;
  	$wp_current_db_version = __get_option('db_version');
  
! 	// We are up-to-date.  Nothing to do.
  	if ( $wp_db_version == $wp_current_db_version )
  		return;
  
--- 389,398 ----
   * @since 1.0.1
   */
  function upgrade_all() {
! 	global $wp_current_db_version, $wp_db_version;
  	$wp_current_db_version = __get_option('db_version');
  
! 	// We are up-to-date. Nothing to do.
  	if ( $wp_db_version == $wp_current_db_version )
  		return;
  
***************
*** 459,464 ****
--- 457,465 ----
  	if ( $wp_current_db_version < 19389 )
  		upgrade_330();
  
+ 	if ( $wp_current_db_version < 20080 )
+ 		upgrade_340();
+ 
  	maybe_disable_automattic_widgets();
  
  	update_option( 'db_version', $wp_db_version );
***************
*** 565,571 ****
  
  	$time_difference = $all_options->time_difference;
  
! 	$server_time = time()+date('Z');
  	$weblogger_time = $server_time + $time_difference*3600;
  	$gmt_time = time();
  
--- 566,572 ----
  
  	$time_difference = $all_options->time_difference;
  
! 		$server_time = time()+date('Z');
  	$weblogger_time = $server_time + $time_difference*3600;
  	$gmt_time = time();
  
***************
*** 646,652 ****
  	$active_plugins = __get_option('active_plugins');
  
  	// If plugins are not stored in an array, they're stored in the old
! 	// newline separated format.  Convert to new format.
  	if ( !is_array( $active_plugins ) ) {
  		$active_plugins = explode("\n", trim($active_plugins));
  		update_option('active_plugins', $active_plugins);
--- 647,653 ----
  	$active_plugins = __get_option('active_plugins');
  
  	// If plugins are not stored in an array, they're stored in the old
! 	// newline separated format. Convert to new format.
  	if ( !is_array( $active_plugins ) ) {
  		$active_plugins = explode("\n", trim($active_plugins));
  		update_option('active_plugins', $active_plugins);
***************
*** 898,906 ****
  		$wpdb->insert( $wpdb->term_relationships, array('object_id' => $post_id, 'term_taxonomy_id' => $tt_id) );
  	}
  
! 	// < 3570 we used linkcategories.  >= 3570 we used categories and link2cat.
  	if ( $wp_current_db_version < 3570 ) {
! 		// Create link_category terms for link categories.  Create a map of link cat IDs
  		// to link_category terms.
  		$link_cat_id_map = array();
  		$default_link_cat = 0;
--- 899,907 ----
  		$wpdb->insert( $wpdb->term_relationships, array('object_id' => $post_id, 'term_taxonomy_id' => $tt_id) );
  	}
  
! 	// < 3570 we used linkcategories. >= 3570 we used categories and link2cat.
  	if ( $wp_current_db_version < 3570 ) {
! 		// Create link_category terms for link categories. Create a map of link cat IDs
  		// to link_category terms.
  		$link_cat_id_map = array();
  		$default_link_cat = 0;
***************
*** 1151,1161 ****
  		$wpdb->query( "DELETE FROM $wpdb->usermeta WHERE meta_key IN ('show_admin_bar_admin', 'plugins_last_view')" );
  	}
  
- 	// 3.3-beta. Can remove before release.
- 	if ( $wp_current_db_version > 18715 && $wp_current_db_version < 19389
- 		&& is_main_site() && ! defined( 'DO_NOT_UPGRADE_GLOBAL_TABLES' ) )
- 			delete_metadata( 'user', 0, 'dismissed_wp_pointers', '', true );
- 
  	if ( $wp_current_db_version >= 11548 )
  		return;
  
--- 1152,1157 ----
***************
*** 1214,1219 ****
--- 1210,1248 ----
  }
  
  /**
+  * Execute changes made in WordPress 3.4.
+  *
+  * @since 3.4.0
+  */
+ function upgrade_340() {
+ 	global $wp_current_db_version, $wpdb;
+ 
+ 	if ( $wp_current_db_version < 19798 ) {
+ 		$wpdb->hide_errors();
+ 		$wpdb->query( "ALTER TABLE $wpdb->options DROP COLUMN blog_id" );
+ 		$wpdb->show_errors();
+ 	}
+ 
+ 	if ( $wp_current_db_version < 19799 ) {
+ 		$wpdb->hide_errors();
+ 		$wpdb->query("ALTER TABLE $wpdb->comments DROP INDEX comment_approved");
+ 		$wpdb->show_errors();
+ 	}
+ 
+ 	if ( $wp_current_db_version < 20022 && is_main_site() && ! defined( 'DO_NOT_UPGRADE_GLOBAL_TABLES' ) ) {
+ 		$wpdb->query( "DELETE FROM $wpdb->usermeta WHERE meta_key = 'themes_last_view'" );
+ 	}
+ 
+ 	if ( $wp_current_db_version < 20080 ) {
+ 		if ( 'yes' == $wpdb->get_var( "SELECT autoload FROM $wpdb->options WHERE option_name = 'uninstall_plugins'" ) ) {
+ 			$uninstall_plugins = get_option( 'uninstall_plugins' );
+ 			delete_option( 'uninstall_plugins' );
+ 			add_option( 'uninstall_plugins', $uninstall_plugins, null, 'no' );
+ 		}
+ 	}
+ }
+ 
+ /**
   * Execute network level changes
   *
   * @since 3.0.0
***************
*** 1258,1263 ****
--- 1290,1312 ----
  		if ( false === get_site_option( 'active_sitewide_plugins' ) )
  			update_site_option( 'active_sitewide_plugins', array() );
  	}
+ 
+ 	// 3.4
+ 	if ( $wp_current_db_version < 20148 ) {
+ 		// 'allowedthemes' keys things by stylesheet. 'allowed_themes' keyed things by name.
+ 		$allowedthemes  = get_site_option( 'allowedthemes'  );
+ 		$allowed_themes = get_site_option( 'allowed_themes' );
+ 		if ( false === $allowedthemes && is_array( $allowed_themes ) && $allowed_themes ) {
+ 			$converted = array();
+ 			$themes = wp_get_themes();
+ 			foreach ( $themes as $stylesheet => $theme_data ) {
+ 				if ( isset( $allowed_themes[ $theme_data->get('Name') ] ) )
+ 					$converted[ $stylesheet ] = true;
+ 			}
+ 			update_site_option( 'allowedthemes', $converted );
+ 			delete_site_option( 'allowed_themes' );
+ 		}
+ 	}
  }
  
  // The functions we use to actually do stuff
***************
*** 1335,1343 ****
   **           false on error
   */
  function maybe_add_column($table_name, $column_name, $create_ddl) {
! 	global $wpdb, $debug;
  	foreach ($wpdb->get_col("DESC $table_name", 0) as $column ) {
- 		if ($debug) echo("checking $column == $column_name<br />");
  		if ($column == $column_name) {
  			return true;
  		}
--- 1384,1391 ----
   **           false on error
   */
  function maybe_add_column($table_name, $column_name, $create_ddl) {
! 	global $wpdb;
  	foreach ($wpdb->get_col("DESC $table_name", 0) as $column ) {
  		if ($column == $column_name) {
  			return true;
  		}
***************
*** 1362,1375 ****
   */
  function get_alloptions_110() {
  	global $wpdb;
! 	if ($options = $wpdb->get_results("SELECT option_name, option_value FROM $wpdb->options")) {
! 		foreach ($options as $option) {
! 			// "When trying to design a foolproof system,
! 			//  never underestimate the ingenuity of the fools :)" -- Dougal
! 			if ('siteurl' == $option->option_name) $option->option_value = preg_replace('|/+$|', '', $option->option_value);
! 			if ('home' == $option->option_name) $option->option_value = preg_replace('|/+$|', '', $option->option_value);
! 			if ('category_base' == $option->option_name) $option->option_value = preg_replace('|/+$|', '', $option->option_value);
! 			$all_options->{$option->option_name} = stripslashes($option->option_value);
  		}
  	}
  	return $all_options;
--- 1410,1421 ----
   */
  function get_alloptions_110() {
  	global $wpdb;
! 	$all_options = new stdClass;
! 	if ( $options = $wpdb->get_results( "SELECT option_name, option_value FROM $wpdb->options" ) ) {
! 		foreach ( $options as $option ) {
! 			if ( 'siteurl' == $option->option_name || 'home' == $option->option_name || 'category_base' == $option->option_name )
! 				$option->option_value = untrailingslashit( $option->option_value );
! 			$all_options->{$option->option_name} = stripslashes( $option->option_value );
  		}
  	}
  	return $all_options;
***************
*** 1387,1410 ****
  function __get_option($setting) {
  	global $wpdb;
  
! 	if ( $setting == 'home' && defined( 'WP_HOME' ) ) {
! 		return preg_replace( '|/+$|', '', WP_HOME );
! 	}
  
! 	if ( $setting == 'siteurl' && defined( 'WP_SITEURL' ) ) {
! 		return preg_replace( '|/+$|', '', WP_SITEURL );
! 	}
  
! 	$option = $wpdb->get_var( $wpdb->prepare("SELECT option_value FROM $wpdb->options WHERE option_name = %s", $setting) );
  
  	if ( 'home' == $setting && '' == $option )
! 		return __get_option('siteurl');
  
! 	if ( 'siteurl' == $setting || 'home' == $setting || 'category_base' == $setting )
! 		$option = preg_replace('|/+$|', '', $option);
  
! 	@ $kellogs = unserialize($option);
! 	if ($kellogs !== FALSE)
  		return $kellogs;
  	else
  		return $option;
--- 1433,1454 ----
  function __get_option($setting) {
  	global $wpdb;
  
! 	if ( $setting == 'home' && defined( 'WP_HOME' ) )
! 		return untrailingslashit( WP_HOME );
  
! 	if ( $setting == 'siteurl' && defined( 'WP_SITEURL' ) )
! 		return untrailingslashit( WP_SITEURL );
  
! 	$option = $wpdb->get_var( $wpdb->prepare("SELECT option_value FROM $wpdb->options WHERE option_name = %s", $setting ) );
  
  	if ( 'home' == $setting && '' == $option )
! 		return __get_option( 'siteurl' );
  
! 	if ( 'siteurl' == $setting || 'home' == $setting || 'category_base' == $setting || 'tag_base' == $setting )
! 		$option = untrailingslashit( $option );
  
! 	@ $kellogs = unserialize( $option );
! 	if ( $kellogs !== false )
  		return $kellogs;
  	else
  		return $option;
***************
*** 1457,1463 ****
  	// Separate individual queries into an array
  	if ( !is_array($queries) ) {
  		$queries = explode( ';', $queries );
! 		if ('' == $queries[count($queries) - 1]) array_pop($queries);
  	}
  	$queries = apply_filters( 'dbdelta_queries', $queries );
  
--- 1501,1507 ----
  	// Separate individual queries into an array
  	if ( !is_array($queries) ) {
  		$queries = explode( ';', $queries );
! 		$queries = array_filter( $queries );
  	}
  	$queries = apply_filters( 'dbdelta_queries', $queries );
  
***************
*** 1468,1474 ****
  	// Create a tablename index for an array ($cqueries) of queries
  	foreach($queries as $qry) {
  		if (preg_match("|CREATE TABLE ([^ ]*)|", $qry, $matches)) {
! 			$cqueries[trim( strtolower($matches[1]), '`' )] = $qry;
  			$for_update[$matches[1]] = 'Created table '.$matches[1];
  		} else if (preg_match("|CREATE DATABASE ([^ ]*)|", $qry, $matches)) {
  			array_unshift($cqueries, $qry);
--- 1512,1518 ----
  	// Create a tablename index for an array ($cqueries) of queries
  	foreach($queries as $qry) {
  		if (preg_match("|CREATE TABLE ([^ ]*)|", $qry, $matches)) {
! 			$cqueries[ trim( $matches[1], '`' ) ] = $qry;
  			$for_update[$matches[1]] = 'Created table '.$matches[1];
  		} else if (preg_match("|CREATE DATABASE ([^ ]*)|", $qry, $matches)) {
  			array_unshift($cqueries, $qry);
***************
*** 1667,1673 ****
   *
   * @since 1.5.0
   */
! function make_db_current_silent(  $tables = 'all' ) {
  	$alterations = dbDelta( $tables );
  }
  
--- 1711,1717 ----
   *
   * @since 1.5.0
   */
! function make_db_current_silent( $tables = 'all' ) {
  	$alterations = dbDelta( $tables );
  }
  
***************
*** 1690,1696 ****
  		return false;
  
  	// Copy files from the old locations to the site theme.
! 	// TODO: This does not copy arbitrary include dependencies.  Only the
  	// standard WP files are copied.
  	$files = array('index.php' => 'index.php', 'wp-layout.css' => 'style.css', 'wp-comments.php' => 'comments.php', 'wp-comments-popup.php' => 'comments-popup.php');
  
--- 1734,1740 ----
  		return false;
  
  	// Copy files from the old locations to the site theme.
! 	// TODO: This does not copy arbitrary include dependencies. Only the
  	// standard WP files are copied.
  	$files = array('index.php' => 'index.php', 'wp-layout.css' => 'style.css', 'wp-comments.php' => 'comments.php', 'wp-comments-popup.php' => 'comments-popup.php');
  
***************
*** 1848,1859 ****
  
  	if (file_exists(ABSPATH . 'wp-layout.css')) {
  		if (! make_site_theme_from_oldschool($theme_name, $template)) {
! 			// TODO:  rm -rf the site theme directory.
  			return false;
  		}
  	} else {
  		if (! make_site_theme_from_default($theme_name, $template))
! 			// TODO:  rm -rf the site theme directory.
  			return false;
  	}
  
--- 1892,1903 ----
  
  	if (file_exists(ABSPATH . 'wp-layout.css')) {
  		if (! make_site_theme_from_oldschool($theme_name, $template)) {
! 			// TODO: rm -rf the site theme directory.
  			return false;
  		}
  	} else {
  		if (! make_site_theme_from_default($theme_name, $template))
! 			// TODO: rm -rf the site theme directory.
  			return false;
  	}
  
***************
*** 1938,1944 ****
  
  	// Upgrade versions prior to 2.9
  	if ( $wp_current_db_version < 11557 ) {
! 		// Delete duplicate options.  Keep the option with the highest option_id.
  		$wpdb->query("DELETE o1 FROM $wpdb->options AS o1 JOIN $wpdb->options AS o2 USING (`option_name`) WHERE o2.option_id > o1.option_id");
  
  		// Drop the old primary key and add the new.
--- 1982,1988 ----
  
  	// Upgrade versions prior to 2.9
  	if ( $wp_current_db_version < 11557 ) {
! 		// Delete duplicate options. Keep the option with the highest option_id.
  		$wpdb->query("DELETE o1 FROM $wpdb->options AS o1 JOIN $wpdb->options AS o2 USING (`option_name`) WHERE o2.option_id > o1.option_id");
  
  		// Drop the old primary key and add the new.
***************
*** 1974,1977 ****
  	dbDelta( $ms_queries );
  }
  endif;
- ?>
--- 2018,2020 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/user.php ./wordpress-3.4/wp-admin/includes/user.php
*** ./wordpress-3.3.2/wp-admin/includes/user.php	2011-09-29 01:12:51.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/user.php	2012-05-08 12:01:50.000000000 -0500
***************
*** 9,46 ****
  /**
   * Creates a new user from the "Users" form using $_POST information.
   *
-  * It seems that the first half is for backwards compatibility, but only
-  * has the ability to alter the user's role. WordPress core seems to
-  * use this function only in the second way, running edit_user() with
-  * no id so as to create a new user.
-  *
   * @since 2.0
   *
-  * @param int $user_id Optional. User ID.
   * @return null|WP_Error|int Null when adding user, WP_Error or User ID integer when no parameters.
   */
  function add_user() {
! 	if ( func_num_args() ) { // The hackiest hack that ever did hack
! 		global $wp_roles;
! 		$user_id = (int) func_get_arg( 0 );
! 
! 		if ( isset( $_POST['role'] ) ) {
! 			$new_role = sanitize_text_field( $_POST['role'] );
! 			// Don't let anyone with 'edit_users' (admins) edit their own role to something without it.
! 			if ( $user_id != get_current_user_id() || $wp_roles->role_objects[$new_role]->has_cap( 'edit_users' ) ) {
! 				// If the new role isn't editable by the logged-in user die with error
! 				$editable_roles = get_editable_roles();
! 				if ( empty( $editable_roles[$new_role] ) )
! 					wp_die(__('You can&#8217;t give users that role.'));
! 
! 				$user = new WP_User( $user_id );
! 				$user->set_role( $new_role );
! 			}
! 		}
! 	} else {
! 		add_action( 'user_register', 'add_user' ); // See above
! 		return edit_user();
! 	}
  }
  
  /**
--- 9,20 ----
  /**
   * Creates a new user from the "Users" form using $_POST information.
   *
   * @since 2.0
   *
   * @return null|WP_Error|int Null when adding user, WP_Error or User ID integer when no parameters.
   */
  function add_user() {
! 	return edit_user();
  }
  
  /**
***************
*** 263,278 ****
  	global $wpdb;
  
  	$id = (int) $id;
  
  	// allow for transaction statement
  	do_action('delete_user', $id);
  
  	if ( 'novalue' === $reassign || null === $reassign ) {
! 		$post_ids = $wpdb->get_col( $wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_author = %d", $id) );
  
  		if ( $post_ids ) {
  			foreach ( $post_ids as $post_id )
! 				wp_delete_post($post_id);
  		}
  
  		// Clean links
--- 237,263 ----
  	global $wpdb;
  
  	$id = (int) $id;
+ 	$user = new WP_User( $id );
  
  	// allow for transaction statement
  	do_action('delete_user', $id);
  
  	if ( 'novalue' === $reassign || null === $reassign ) {
! 		$post_types_to_delete = array();
! 		foreach ( get_post_types( array(), 'objects' ) as $post_type ) {
! 			if ( $post_type->delete_with_user ) {
! 				$post_types_to_delete[] = $post_type->name;
! 			} elseif ( null === $post_type->delete_with_user && post_type_supports( $post_type->name, 'author' ) ) {
! 				$post_types_to_delete[] = $post_type->name;
! 			}
! 		}
  
+ 		$post_types_to_delete = apply_filters( 'post_types_to_delete_with_user', $post_types_to_delete, $id );
+ 		$post_types_to_delete = implode( "', '", $post_types_to_delete );
+ 		$post_ids = $wpdb->get_col( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_author = %d AND post_type IN ('$post_types_to_delete')", $id ) );
  		if ( $post_ids ) {
  			foreach ( $post_ids as $post_id )
! 				wp_delete_post( $post_id );
  		}
  
  		// Clean links
***************
*** 288,304 ****
  		$wpdb->update( $wpdb->links, array('link_owner' => $reassign), array('link_owner' => $id) );
  	}
  
- 	clean_user_cache($id);
- 
  	// FINALLY, delete user
! 	if ( !is_multisite() ) {
! 		$wpdb->query( $wpdb->prepare("DELETE FROM $wpdb->usermeta WHERE user_id = %d", $id) );
! 		$wpdb->query( $wpdb->prepare("DELETE FROM $wpdb->users WHERE ID = %d", $id) );
  	} else {
! 		$level_key = $wpdb->get_blog_prefix() . 'capabilities'; // wpmu site admins don't have user_levels
! 		$wpdb->query("DELETE FROM $wpdb->usermeta WHERE user_id = $id AND meta_key = '{$level_key}'");
  	}
  
  	// allow for commit transaction
  	do_action('deleted_user', $id);
  
--- 273,291 ----
  		$wpdb->update( $wpdb->links, array('link_owner' => $reassign), array('link_owner' => $id) );
  	}
  
  	// FINALLY, delete user
! 	if ( is_multisite() ) {
! 		remove_user_from_blog( $id, get_current_blog_id() );
  	} else {
! 		$meta = $wpdb->get_col( $wpdb->prepare( "SELECT umeta_id FROM $wpdb->usermeta WHERE user_id = %d", $id ) );
! 		foreach ( $meta as $mid )
! 			delete_metadata_by_mid( 'user', $mid );
! 
! 		$wpdb->delete( $wpdb->users, array( 'ID' => $id ) );
  	}
  
+ 	clean_user_cache( $user );
+ 
  	// allow for commit transaction
  	do_action('deleted_user', $id);
  
***************
*** 369,373 ****
  	printf( '<a href="%s" id="default-password-nag-no">' . __('No thanks, do not remind me again') . '</a>', '?default_password_nag=0' );
  	echo '</p></div>';
  }
- 
- ?>
--- 356,358 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/index.php ./wordpress-3.4/wp-admin/index.php
*** ./wordpress-3.3.2/wp-admin/index.php	2011-12-01 22:31:01.000000000 -0600
--- ./wordpress-3.4/wp-admin/index.php	2012-05-03 11:41:59.000000000 -0500
***************
*** 19,24 ****
--- 19,27 ----
  wp_enqueue_script( 'media-upload' );
  add_thickbox();
  
+ if ( wp_is_mobile() )
+ 	wp_enqueue_script( 'jquery-touch-punch' );
+ 
  $title = __('Dashboard');
  $parent_file = 'index.php';
  
***************
*** 59,72 ****
  ) );
  
  $help  = '<p>' . __('The boxes on your Dashboard screen are:') . '</p>';
! $help .= '<p>' . __('<strong>Right Now</strong> - Displays a summary of the content on your site and identifies which theme and version of WordPress you are using.') . '</p>';
! $help .= '<p>' . __('<strong>Recent Comments</strong> - Shows the most recent comments on your posts (configurable, up to 30) and allows you to moderate them.') . '</p>';
! $help .= '<p>' . __('<strong>Incoming Links</strong> - Shows links to your site found by Google Blog Search.') . '</p>';
! $help .= '<p>' . __('<strong>QuickPress</strong> - Allows you to create a new post and either publish it or save it as a draft.') . '</p>';
! $help .= '<p>' . __('<strong>Recent Drafts</strong> - Displays links to the 5 most recent draft posts you&#8217;ve started.') . '</p>';
  $help .= '<p>' . __('<strong>WordPress Blog</strong> - Latest news from the official WordPress project.') . '</p>';
  $help .= '<p>' . __('<strong>Other WordPress News</strong> - Shows the <a href="http://planet.wordpress.org" target="_blank">WordPress Planet</a> feed. You can configure it to show a different feed of your choosing.') . '</p>';
! $help .= '<p>' . __('<strong>Plugins</strong> - Features the most popular, newest, and recently updated plugins from the WordPress.org Plugin Directory.') . '</p>';
  
  get_current_screen()->add_help_tab( array(
  	'id'      => 'help-content',
--- 61,82 ----
  ) );
  
  $help  = '<p>' . __('The boxes on your Dashboard screen are:') . '</p>';
! if ( current_user_can( 'edit_posts' ) )
! 	$help .= '<p>' . __('<strong>Right Now</strong> - Displays a summary of the content on your site and identifies which theme and version of WordPress you are using.') . '</p>';
! if ( current_user_can( 'moderate_comments' ) )
! 	$help .= '<p>' . __('<strong>Recent Comments</strong> - Shows the most recent comments on your posts (configurable, up to 30) and allows you to moderate them.') . '</p>';
! if ( current_user_can( 'publish_posts' ) )
! 	$help .= '<p>' . __('<strong>Incoming Links</strong> - Shows links to your site found by Google Blog Search.') . '</p>';
! if ( current_user_can( 'edit_posts' ) ) {
! 	$help .= '<p>' . __('<strong>QuickPress</strong> - Allows you to create a new post and either publish it or save it as a draft.') . '</p>';
! 	$help .= '<p>' . __('<strong>Recent Drafts</strong> - Displays links to the 5 most recent draft posts you&#8217;ve started.') . '</p>';
! }
  $help .= '<p>' . __('<strong>WordPress Blog</strong> - Latest news from the official WordPress project.') . '</p>';
  $help .= '<p>' . __('<strong>Other WordPress News</strong> - Shows the <a href="http://planet.wordpress.org" target="_blank">WordPress Planet</a> feed. You can configure it to show a different feed of your choosing.') . '</p>';
! if ( ! is_multisite() && current_user_can( 'install_plugins' ) )
! 	$help .= '<p>' . __('<strong>Plugins</strong> - Features the most popular, newest, and recently updated plugins from the WordPress.org Plugin Directory.') . '</p>';
! if ( current_user_can( 'edit_theme_options' ) )
! 	$help .= '<p>' . __('<strong>Welcome</strong> - Shows links for some of the most common tasks when setting up a new site.') . '</p>';
  
  get_current_screen()->add_help_tab( array(
  	'id'      => 'help-content',
